import { AnimationBuilder, AnimationPlayer } from '@angular/animations';
import { AfterViewInit, ElementRef, EventEmitter, QueryList } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { LastTouch } from '../../interfaces/last-touch';
import { StartTouch } from '../../interfaces/start-touch';
import { BsSwipeDirective } from '../swipe/swipe.directive';
import * as i0 from "@angular/core";
export declare class BsSwipeContainerDirective implements AfterViewInit {
    private animationBuilder;
    constructor(element: ElementRef, animationBuilder: AnimationBuilder, document: any);
    offsetLeft: number | null;
    offsetRight: number | null;
    offsetTop: number | null;
    offsetBottom: number | null;
    set swipes(value: QueryList<BsSwipeDirective>);
    minimumOffset: number;
    get imageIndex(): number;
    set imageIndex(value: number);
    imageIndexChange: EventEmitter<number>;
    actualSwipes$: Observable<BsSwipeDirective[]>;
    isViewInited$: BehaviorSubject<boolean>;
    startTouch$: BehaviorSubject<StartTouch | null>;
    lastTouch$: BehaviorSubject<LastTouch | null>;
    swipes$: BehaviorSubject<QueryList<BsSwipeDirective> | null>;
    imageIndex$: BehaviorSubject<number>;
    slideHeights$: Observable<number[]>;
    currentSlideHeight$: Observable<number>;
    pendingAnimation?: AnimationPlayer;
    containerElement: ElementRef<HTMLDivElement>;
    document: Document;
    offset$: Observable<number>;
    offsetLeft$: Observable<number>;
    offsetRight$: Observable<number>;
    padLeft$: Observable<number>;
    padRight$: Observable<number>;
    ngAfterViewInit(): void;
    animateToIndexByDx(dx: number): void;
    animateToIndex(oldIndex: number, newIndex: number, dx: number, totalSlides: number): void;
    onSwipe(dx: number): void;
    previous(): void;
    next(): void;
    goto(index: number): void;
    private gotoAnimate;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSwipeContainerDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BsSwipeContainerDirective, "[bsSwipeContainer]", ["bsSwipeContainer"], { "minimumOffset": { "alias": "minimumOffset"; "required": false; }; "imageIndex": { "alias": "imageIndex"; "required": false; }; }, { "imageIndexChange": "imageIndexChange"; }, ["swipes"], never, false, never>;
}
